from functools import wraps
import services
import sims4.resources
from sims4.tuning.instance_manager import InstanceManager
from sims4.resources import Types

def inject(target_function, new_function):
    @wraps(target_function)
    def _inject(*args, **kwargs):
        return new_function(target_function, *args, **kwargs)
    return _inject

def inject_to(target_object, target_function_name):
    def _inject_to(new_function):
        target_function = getattr(target_object, target_function_name)
        setattr(target_object, target_function_name, inject(target_function, new_function))
        return new_function
    return _inject_to

SeSeSimmi_WeddingBells_ObjectIds_1 = (14965,)
SeSeSimmi_WeddingBells_InteractionIds_1 = (4092919272,3675349550,3293114127,2438951592,)
@inject_to(InstanceManager, 'load_data_into_class_instances')
def SeSeSimmi_WeddingBells_AddSuperAffordances_1(original, self):
    original(self)
    if self.TYPE == Types.OBJECT:
        affordance_manager = services.affordance_manager()
        sa_list = []
        for sa_id in SeSeSimmi_WeddingBells_InteractionIds_1:
            key = sims4.resources.get_resource_key(sa_id, Types.INTERACTION)
            sa_tuning = affordance_manager.get(key)
            if not sa_tuning is None:
                sa_list.append(sa_tuning)
        sa_tuple = tuple(sa_list)
        for obj_id in SeSeSimmi_WeddingBells_ObjectIds_1:
            key = sims4.resources.get_resource_key(obj_id, Types.OBJECT)
            obj_tuning = self._tuned_classes.get(key)
            if not obj_tuning is None:
                obj_tuning._super_affordances = obj_tuning._super_affordances + sa_tuple
SeSeSimmi_WeddingBells_ObjectIds_2 = (149493,)
SeSeSimmi_WeddingBells_InteractionIds_2 = (2237336663,)
@inject_to(InstanceManager, 'load_data_into_class_instances')
def SeSeSimmi_WeddingBells_AddSuperAffordances_2(original, self):
    original(self)
    if self.TYPE == Types.OBJECT:
        affordance_manager = services.affordance_manager()
        sa_list = []
        for sa_id in SeSeSimmi_WeddingBells_InteractionIds_2:
            key = sims4.resources.get_resource_key(sa_id, Types.INTERACTION)
            sa_tuning = affordance_manager.get(key)
            if not sa_tuning is None:
                sa_list.append(sa_tuning)
        sa_tuple = tuple(sa_list)
        for obj_id in SeSeSimmi_WeddingBells_ObjectIds_2:
            key = sims4.resources.get_resource_key(obj_id, Types.OBJECT)
            obj_tuning = self._tuned_classes.get(key)
            if not obj_tuning is None:
                obj_tuning._super_affordances = obj_tuning._super_affordances + sa_tuple
SeSeSimmi_WeddingBells_TargetInteractionIds_1 = (2237336663,)
@inject_to(InstanceManager, 'load_data_into_class_instances')
def SeSeSimmi_WeddingBells_AddSuperAffordances_BasedOnInteraction_1(original, self):
    original(self)
    if self.TYPE == Types.OBJECT:
        affordance_manager = services.affordance_manager()
        sa_list = []
        for sa_id in SeSeSimmi_WeddingBells_TargetInteractionIds_1:
            sa_tuning = affordance_manager.get(sims4.resources.get_resource_key(sa_id, Types.INTERACTION))
            if not sa_tuning is None:
                sa_list.append(sa_tuning)
        sa_tuple = tuple(sa_list)
        object_manager = services.get_instance_manager(Types.OBJECT)
        for obj_tuning in object_manager.types.values():
            if obj_tuning is None:
                continue
            if affordance_manager.get(sims4.resources.get_resource_key(13782, Types.INTERACTION)) in obj_tuning._super_affordances:
                obj_tuning._super_affordances = obj_tuning._super_affordances + sa_tuple
SeSeSimmi_WeddingBells_ObjectIds_Phone = (14965,)
SeSeSimmi_WeddingBells_InteractionIds_Phone = (2591996850,4092919272,2237336663,)
@inject_to(InstanceManager, 'load_data_into_class_instances')
def SeSeSimmi_WeddingBells_AddSuperAffordances_Phone(original, self):
    original(self)
    if self.TYPE == Types.OBJECT:
        affordance_manager = services.affordance_manager()
        sa_list = []
        for sa_id in SeSeSimmi_WeddingBells_InteractionIds_Phone:
            key = sims4.resources.get_resource_key(sa_id, Types.INTERACTION)
            sa_tuning = affordance_manager.get(key)
            if not sa_tuning is None:
                sa_list.append(sa_tuning)
        sa_tuple = tuple(sa_list)
        for obj_id in SeSeSimmi_WeddingBells_ObjectIds_Phone:
            key = sims4.resources.get_resource_key(obj_id, Types.OBJECT)
            obj_tuning = self._tuned_classes.get(key)
            if not obj_tuning is None:
                obj_tuning._phone_affordances = obj_tuning._phone_affordances + sa_tuple

SeSeSimmi_WeddingBells_163702_SnippetId = 163702
SeSeSimmi_WeddingBells_163702_MixerId = (2760803342,2480613972,2794458441,2184635849,3853906637,2494139564,2581204604,2386139514,2377367506,3758152935,3394254418,3369684803,2150020707,2409157272,2732733234,3966892395,4245093173,3663832272,4133738770,3016214379,3177318419,4253967132,2812137451,4149522351,4035972092,3773074694,4271792531,2540929893,2464102499,3091611012,3411999985,2982692374,3024864791,3700461271,3896480947,4128125926,3716331351,2357186895,2327012368,3408562781,3533512129,3248890574,3736854630,2708221879,3166466985,2855752665,2559102778,3697885382,4104420276,2397641290,2802566003,2569340224,2591078217,3230842760,3027533296,3820830017,3261869120,3538548012,4013294647,2703331975,4123561180,4109039096,3257623243,3422255638,2719755435,2213256626,3611689885,2723818277,3248263034,3640723534,4047918912,)
@inject_to(InstanceManager, 'load_data_into_class_instances')
def SeSeSimmi_WeddingBells_AddMixer_163702(original, self):
    original(self)
    if self.TYPE == Types.SNIPPET:
        key = sims4.resources.get_resource_key(SeSeSimmi_WeddingBells_163702_SnippetId, Types.SNIPPET)
        snippet_tuning = self._tuned_classes.get(key)
        if snippet_tuning is None:
            return
        for m_id in SeSeSimmi_WeddingBells_163702_MixerId:
            affordance_manager = services.affordance_manager()
            key = sims4.resources.get_resource_key(m_id, Types.INTERACTION)
            mixer_tuning = affordance_manager.get(key)
            if mixer_tuning is None:
                continue
            if mixer_tuning in snippet_tuning.value:
                continue
            snippet_tuning.value = snippet_tuning.value + (mixer_tuning, )
SeSeSimmi_WeddingBells_163706_SnippetId = 163706
SeSeSimmi_WeddingBells_163706_MixerId = (2162367102,)
@inject_to(InstanceManager, 'load_data_into_class_instances')
def SeSeSimmi_WeddingBells_AddMixer_163706(original, self):
    original(self)
    if self.TYPE == Types.SNIPPET:
        key = sims4.resources.get_resource_key(SeSeSimmi_WeddingBells_163706_SnippetId, Types.SNIPPET)
        snippet_tuning = self._tuned_classes.get(key)
        if snippet_tuning is None:
            return
        for m_id in SeSeSimmi_WeddingBells_163706_MixerId:
            affordance_manager = services.affordance_manager()
            key = sims4.resources.get_resource_key(m_id, Types.INTERACTION)
            mixer_tuning = affordance_manager.get(key)
            if mixer_tuning is None:
                continue
            if mixer_tuning in snippet_tuning.value:
                continue
            snippet_tuning.value = snippet_tuning.value + (mixer_tuning, )
SeSeSimmi_WeddingBells_163713_SnippetId = 163713
SeSeSimmi_WeddingBells_163713_MixerId = (2809837006,)
@inject_to(InstanceManager, 'load_data_into_class_instances')
def SeSeSimmi_WeddingBells_AddMixer_163713(original, self):
    original(self)
    if self.TYPE == Types.SNIPPET:
        key = sims4.resources.get_resource_key(SeSeSimmi_WeddingBells_163713_SnippetId, Types.SNIPPET)
        snippet_tuning = self._tuned_classes.get(key)
        if snippet_tuning is None:
            return
        for m_id in SeSeSimmi_WeddingBells_163713_MixerId:
            affordance_manager = services.affordance_manager()
            key = sims4.resources.get_resource_key(m_id, Types.INTERACTION)
            mixer_tuning = affordance_manager.get(key)
            if mixer_tuning is None:
                continue
            if mixer_tuning in snippet_tuning.value:
                continue
            snippet_tuning.value = snippet_tuning.value + (mixer_tuning, )

